
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>从活动目录中获取域管理员权限的6种方法 / iVAN</title>

    <meta name="description" content="从活动目录中获取域管理员权限的6种方法 本文讲的是从活动目录中获取域管理员权限的6种方法,通常,在大多数企业当中,攻击者根本不需要太长的时间,就可以将域中普通用户的权限提升到域管理员的权限.公司运维人员会困惑,&quot;这一切都是怎么发生的?&quot; 一次攻击,往往开始于公司中的一个或多个用户打开了恶意邮件,使得攻击者可以在目标网络中的计算机上执行恶意代码.一旦恶意代码被运行,攻击者就会利用恶意代码对企业内网进行侦查,以便于发现有用的资源进行提权,进行持久控制,当然,他们还有可能进行信息掠夺. 虽然整体的细节以及流程大多不同,但 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">从活动目录中获取域管理员权限的6种方法</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本文讲的是<b>从活动目录中获取域管理员权限的6种方法</b>，通常，在大多数企业当中，攻击者根本不需要太长的时间，就可以将域中普通用户的权限提升到域管理员的权限。公司运维人员会困惑，“这一切都是怎么发生的？”</p>
<p>一次攻击，往往开始于公司中的一个或多个用户打开了恶意邮件，使得攻击者可以在目标网络中的计算机上执行恶意代码。一旦恶意代码被运行，攻击者就会利用恶意代码对企业内网进行侦查，以便于发现有用的资源进行提权，进行持久控制，当然，他们还有可能进行信息掠夺。</p>
<p>虽然整体的细节以及流程大多不同，但是他们的目的几乎是一样的，如：</p>
<pre>恶意软件注入(web应用漏洞利用，Spear-Phish网络钓鱼攻击等等)
进行内网信息收集
嗅探密钥
进行攻击以及提权
获取数据
持久控制</pre>
<p>我们从攻击者进入内网区域开始讲述，因为这在真实网络环境中，并不是很困难的事情。此外，攻击者从主机普通用户权限提升到本地管理员的权限并不是那么困难，他们可以通过利用主机未修补的提权漏洞进行提权，或者从SYSVOL中找到本地管理员的密码，比如：组策略首选项。</p>
<p>我曾经在会议上分享过许多关于这种攻击的方法，也在文章里中介绍过。<br />
下面，我们就开始我们的正文吧～</p>
<p><strong>从域普通用户到域管理员的攻击方法：</strong></p>
<p><strong>1.SYSVOL和组策略首选项中的密码</strong></p>
<p>因为不使用任何工具，所以这种攻击方法是最简单的。攻击者需要做的就是打开windows任务管理器，并搜索名为SYSVOL<br />
DFS的共享XML文档。大多数情况下，以下文档会包含密码：<br />
groups.xml,scheduledtasks.xml以及Services.xml.</p>
<p>SYSVOL是将在域中所有经过身份验证的用户都可以读取权限的活动目录在域中进行共享。SYSVOL包括登录脚本，组策略数据，以及域控需要访问的其他域里面的数据(因为SYSVOL是在所有域控之间自动同步并且共享的)。所有域的组策略都存在于：</p>
<pre>&lt;DOMAIN&gt;SYSVOL&lt;DOMAIN&gt;Policies</pre>
<p>当新的GPP(组策略选项)创建时，会在SYSVOL中创建一个与相关配置数据相关联的XML文件，如果提供了密码，那么加密方式应该是AES-256。</p>
<p>除了在2012年微软公布了AES加密的私钥外,任何经过身份验证的用户(任何域中用户或者受信任域中的用户)都可以查看SYSVOL中的包含AES加密密码的XML文件。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjRob3UuY29tL3VwbG9hZHMvMjAxNzA0MTIvMTQ5MTk5MDc3OTgxNjg5Ny5wbmc=.jpg"></p>
<p>当进入到这个XML文件当中后，攻击者可以使用上述AES的私钥对组策略选项中的密码进行解密。PowerSploit中的一个模块Get-GPPPassword可以对组策略密码进行破解。下面截图就是类似模块对在SYSVOL的GPP密码进行解密的方法。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjRob3UuY29tL3VwbG9hZHMvMjAxNzA0MTIvMTQ5MTk5MDc5NzM2MDIxNy5wbmc=.jpg"></p>
<p>一些其他的文件可能也存在已经嵌入的密码，通常是明文，比如vbs,bat文件。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjRob3UuY29tL3VwbG9hZHMvMjAxNzA0MTIvMTQ5MTk5MDgyMzE0MTUxNS5qcGc=.jpg"></p>
<p>你会认为通过发布的补丁，将管理员的信息不放进组策略就可以避免这个问题的发生，但是我现在在对客户进行安全评估时，依旧可以在SYSVOL中找到用户的密码。</p>
<p>解决方法：</p>
<pre>在用于管理GPO(组策略对象)的每台计算机上安装KB2962486补丁，以防止新的凭据被放置在组策略首选项中。
删除SYSVOL中存在GPP密码的XML文件。
不要将密码暴露在任何域用户面前。</pre>
<p>关于这个攻击方法的更多信息，你可以具体参考这篇文章：https://adsecurity.org/?p=2288</p>
<p><strong>2.在未打补丁的域控上使用MS14-068关于Kerberos的漏洞进行攻击。</strong></p>
<p>自从KB3011780补丁对MS14-068进行修补已经过去一年多了，并且已经有方法可以对MS14-068攻击进行检测和防御，不过这并不意味这所有的域控制器都会对这个漏洞进行检测。大多数的企业都在KB301178发布一个月后对域控上面的漏洞进行修补，但是并不确保新成为域控的服务器都对这个漏洞进行了修复。</p>
<p>感谢@Gavin Millard,让我们可以简单的进行介绍这种攻击。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjRob3UuY29tL3VwbG9hZHMvMjAxNzA0MTIvMTQ5MTk5MDg4NjMxNDQ0NS5wbmc=.jpg"></p>
<p>简单来说，攻击者利用MS14-068可以在5分钟之内重写一个有效的Kerberos<br />
TGT身份验证，并且使他成为域管理员以及目录林管理员。如上图所示，就像采取了有效的登机密码，在登记前，在登机牌上写上”我是飞行员”，然后你就会被安排到驾驶仓，并且还会给你提供咖啡。就好比这种攻击，系统会将普通用户当成了域管理员，然后给予域管理员的权限。<br />
补丁发布两周后，MS14-068漏洞利用的exp第一次公开发布。exp是由Sylvain<br />
Monné编写，被叫做PyKEK.PyKEK是一个可以运行在任何具有Python环境平台上的一个python脚本，当然，这个平台需要能够和未打补丁的域控进行通信。他通过捕获一个ccache文件，然后利用Mimikatz将作为管理员的TGT注入到内存，然后你就可以以域管理员权限进行各种操作。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjRob3UuY29tL3VwbG9hZHMvMjAxNzA0MTIvMTQ5MTk5MDkwMjU4NzUwOS5qcGc=.jpg"></p>
<p><strong>解决方法：</strong>使用补丁，或者域控使用windows2012/2012R2</p>
<p>MS14-068利用过程:</p>
<pre>普通用户发送一个不包含PAC(Privilege Attribute Certificate 特权属性证书)的kerberos TGT 认证请求，然后域控会回复TGT。
生成伪造的PAC，没有密钥，所以生成的PAC是将域用户的密码数据使用MD5算法加密而不是使用HMAC_MD5“签名”。
将没有PAC的TGT以及作为TGS服务认证请求数据的一部分的伪造PAC发送给域控。
域控被发送过来的数据混淆，所以它将用户发送过来的无PAC的TGT丢弃，同时创建一个新的TGT，将我们的伪造的PAC插入到当中，然后将这个新的TGT发送给用户。
通过伪造的新的TGT将用户设置成域管理员。</pre>
<p>Mimikatz的作者Benjamin<br />
Delpy通过改进PyKEK写了一个新的MS14-068的exp，叫做kekeo。这个exp可以发现并且定位存在漏洞的域控，不管在域中是否有补丁，以及是否使用windows2012/2012R2。攻击使用的Exp是和PyKEK相同的，不过他在最后加了一个新的步骤，可以产生一个对任何内网的域控都可以进行访问的TGT。这样就可以在域的任何一处地方执行exp，得到域管权限。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjRob3UuY29tL3VwbG9hZHMvMjAxNzA0MTIvMTQ5MTk5MDkyOTMwNjAyMy5wbmc=.jpg"></p>
<p><strong>解决方案：</strong></p>
<p>1. 确保DCPromo进程在运行DCPromo之前包括一个补丁查询步骤，以检查KB3011780的安装。可以使用PowerShell命令：<code>get-hotfix 3011780</code>进行快速检查。</p>
<p>2. 此外，实施一个自动化过程，确保在系统在不符合规定的情况下运行时，自动应用关键补丁。即设置自动更新补丁</p>
<p>3.kerberos TGS服务凭证离线爆破(kerberoast)</p>
<p>Kerberoast能够使普通用户在不向目标系统发送任何数据包的情况下从活动目录提取服务账户信息。因为大多数人都会使用比较弱的密码，所以这种攻击是一个很好的攻击方法。之所以很容易攻击成功是因为大多数的服务的密码长度都会和域中设置的最小长度相同，这就意味着爆破也不会花费太长的时间，不会导致超过这个密码的到期时间。大多数的服务不会为密码设置到期时间，所以相同的密码可能会几个月或者几年都会生效。此外，大多数的服务权限都赋予的很高，并且一般都是域管理员权限，具有完整的对活动目录操作的权限.(尽管服务帐户只需要能够修改某些对象类型上的属性或持有特定服务器上的管理员权限)<br /><strong>注意:当目标服务是windows的系统管理服务时，这种攻击不会成功，因为他们会在活动目录中产生128个字符的密钥，这暴力破解起来很困难，并且基本不可能实现。</strong></p>
<p>这种攻击方法是为目标账户的服务主体名称一个Kerberos服务凭证(TGS)。这个请求使用一个有效的域用户凭证(TGT)为目标运行的多个服务请求一个或者多个服务凭证。域控一般不会确认这个用户是不是已经连接到这些资源(甚至不确认它是否有权限访问)。域控会在活动目录中查找SPN，并且使用与SPN相关联的账户对凭证进行加密，以便于服务验证用户的访问权限。请求Kerberos服务凭证加密方式为：RC4_HMAC_MD5,这意味着服务账户的NTLM密码用于了加密服务凭证。这也就意味着Kerberoast可以尝试通过尝试不同的NTLM散列来解密Kerberos凭证，并且当凭证成功解密时，会发现正确的服务帐户密码。<br /><strong>注意：这里没有对权限进行提升，以及没有与目标进行任何通信。</strong></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjRob3UuY29tL3VwbG9hZHMvMjAxNzA0MTIvMTQ5MTk5MDk4NzQ5Mzk4Ny5qcGc=.jpg"></p>
<p>Tim Medin在DerbyCon 2014上发表了他的“攻击微软Kerberosd的想法”演示文稿（幻灯片和视频），以及发布了Kerberoast Python TGS破解者。<br />
解决方法：<br />
最有效的防御这种攻击的方法就是将确保服务账户的密码超过25个字符。</p>
<p>使用托管服务帐户和组托管服务帐户是确保服务帐户密码长，复杂以及定期更改的好方法。使用提供密码保管的第三方产品也是管理服务帐户密码的坚实解决方案。</p>
<p>关于这种攻击的详细介绍您可以在这篇文章中可以了解：https://adsecurity.org/?p=2293</p>
<p><strong>4.悄无声息盗窃密码</strong></p>
<p>因为这种方法实在是难以描述，所以我把它叫做了”悄无声息盗窃密码”。将它看成是一次舞蹈演出。先拿下一台简单的服务器，提权，并且将凭证导出。然后通过凭证进入到其他主机中，再进行提权，在进行凭证导出。</p>
<p>由于大多数的活动目录的管理员使用账户登录到他们的主机上面，然后使用RunAs(将其管理员凭据放在本地使用的命令)或者RDP命令连接到远程服务端，所以，这种攻击方法得到域管理员的凭证通常很迅速。</p>
<p>步骤一：拿下一台主机，并且进行提权，得到本地管理员权限，然后运行Mimikatz或者类似导出本地用户信息的工具，得到最近登录的信息以及账户密码。</p>
<p>步骤二：使用步骤一收集的管理员信息，并且尝试这去登陆其他具有管理员权限的机器。一般是会成功的，因为本地的管理员账户很难被设置正确(现在你可以使用微软的LAPS进行配置)。如果你知道了一组管理员的帐号密码，就相当于知道了多个甚至全部主机的账户和密码，这就以为着你有了所有主机的管理员权限。连接到其他主机，并且以同样的方法对这些主机进行本地登录信息的导出，直到得到了域管理员的账户信息。并且，使用本地用户进行登录是一个很隐蔽的方法，这样不需要登录到域管上面，也很少有主机发送安全日志到中央日志记录系统当中(SIEM)。</p>
<p>步骤三：利用被盗取的账户信息收集更多的信息。比如运行一些应用的服务器中，往往具有大量用户信息(更有可能含有域管理员信息)。比如：CAS服务器，OWA服务器，MSSQL服务器，RDP服务器。</p>
<p>步骤四：结束攻击，收尾。<br />
使用被窃取的域管理员的账户，攻击者可以毫无阻碍的得到所有域中的用户信息。</p>
<p>如果域管在所有主机中都在控制着一个服务，那么只要拿下一台机器，就相当于拿下了整个域。</p>
<p>通常PowerShell是一种很好的管理方法，因为通过PowerShell连接到远程系统是一种网络登录（没有凭据存储在远程系统的内存中）。这是理想的，而微软正在通过管理员模式将RDP转变。有一种通过PowerShell远程连接到远程系统的方法，并能够通过CredSSP使用凭据。但是这里的问题是CredSSP不安全。</p>
<p>Joe Bialek在PowershellMagazine.com关于这种连接写到：</p>
<p>“使用PowerShell远程连接时管理员面临的常见问题是“双跳”问题。管理员使用PowerShell远程连接连接到服务器A，然后尝试从服务器A连接到服务器B.不幸的是，在第二步时连接失败。<br />
原因是，默认情况下，PowerShell使用“网络登录”远程处理身份验证。网络登录通过向远程服务器证明您拥有用户凭据而不向该服务器发送凭证（参见Kerberos和NTLM身份验证）。因为远程服务器不拥有凭据，所以当您尝试进行第二跳（从服务器A到服务器B）时，它会失败，因为服务器A没有凭证到服务器B，进行身份验证失败。</p>
<p>为了解决这个问题，PowerShell提供了CredSSP（Credential Security Support<br />
Provider）选项。使用CredSSP时，PowerShell将执行“网络清除文本登录”而不是“网络登录”。网络清除文本登录通过将用户的明文密码发送到远程服务器。使用CredSSP时，服务器A将发送用户的明文密码，因此能够对服务器B进行身份验证。这样”双跳”连接就会成功。<br />
更新：这次实验是在Windows2012上进行的，微软已经在WIN<br />
server2012R2以及win8.1上做出了更改，不会将明文密码存储在内存里面。这就意味着攻击者即使运行Mimikatz也不会得到明文密码，但是攻击者还是可以看到你的NT密码的hash值以及你的Kerberos<br />
TGT，这两者与得到密码相比，都是一样的。都可用于网络身份验证。<br />
此外，即使您的明文凭据未保存在内存中，仍会发送到远程服务器。攻击者可以在本地安全机构子系统服务（LSASS.exe）中注入恶意代码，并在传输过程中拦截您的密码。所以尽管你可能不会再看到你的密码了，你的密码仍然可以被攻击者得到。<br />
所以，请不要使用CredSSP。类似的一个漏洞是在Powershell远程连接中使用的WinRM中的一个配置问题，这个配置叫做：“AllowUnencrypted”。将这个配置选项改为”True”,就会禁用通过这个系统的任何WinRM通信的加密，使用明文传输。当然也包括Powershell远程链接。</p>
<p><strong>5.hash传递攻击到凭证传递攻击</strong></p>
<p>大部分人都应该听过hash传递攻击(pass-the-hash(PtH))，它是通过找到用户密码的hash值来进行攻击的。(通常是NTLM密码hash)，使用PtH进行攻击有趣的地方是，他不需要知道明文密码到底是什么，因为在windows的网络通信中，Hash就是用来对用户身份进行验证的。<br />
微软的产品和工具显然不支持传递哈希攻击，所以需要第三方工具，如Mimikatz。一旦发现密码哈希，Hash传递攻击为攻击者提供了很多途径，但还有其他选择。凭证传递攻击(Pass-the-Ticket(PtT))通过收集已经存在的kerberos凭证，并且使用它进行用户验证。<br />
Mimikatz支持收集当前用户的Kerberos凭证，也可以收集经过系统验证的每个用户的Kerberos凭证（如果配置了Kerberos无约束委托，这可能是一个很大的问题）。一旦获得Kerberos凭证，他们可以使用Mimikatz传递，并用于访问资源（当然是在Kerberos票据生存期内）。</p>
<p>超hash传递攻击(OverPass-the-Hash)又名密钥传递攻击。这种攻击涉及使用获取的密码哈希来获取Kerberos凭证。此技术清除当前用户的所有现有Kerberos密钥（哈希值），并将获取的哈希值注入到Kerberos凭证请求的内存中。下一次需要Kerberos凭证进行资源访问时，注入的散列（现在是内存中的Kerberos密钥）用于请求Kerberos凭证。Mimikatz提供执行OverPass-the-Hash的功能。因为有方法对hash传递攻击进行检测，所以这种方法是相对来说比较好的。</p>
<p>注意：如果获取的散列是NTLM，则Kerberos凭证加密方法是RC4。如果散列加密方法为AES，则Kerberos票使用AES进行的加密。</p>
<p>当然还有很多用来窃取凭证的方法，不过这几种是最常用的：</p>
<ul>
<li>hash传递攻击(PtH):抓住哈希并使用它来访问资源。用户更改帐户密码之前有效。</li>
<li>凭证传递攻击(PtT):抓取Kerberos凭证，并且使用它进行访问资源。攻击有效期是在票证有效期之内(一般为7天)。</li>
<li>超hash传递攻击(OPtH):使用密码哈希来获取Kerberos凭证。用户更改帐户密码之前，哈希才有效。</li>
</ul>
<p>解决方法：</p>
<ul>
<li>管理员应该有管理活动的单独管理主机。管理员帐户不应该登录到正在执行用户活动（如电子邮件和网页浏览）的主机。这会大大减少了盗号机会。请注意，智能卡不会阻止用户信息泄漏，因为在访问智能卡时仍会用到账户对应的hash值。智能卡仅确保正在对系统进行登录的用户拥有智能卡。一旦用于对系统进行身份验证，智能卡双因素身份验证会就会成为使用帐户的密码的一个因素，也就是用户密码的hash值。此外，一旦帐户配置为智能卡身份验证，系统会为该帐户生成一个新密码（并且从未更改）。</li>
<li>主机和服务器上的所有本地管理员帐户密码应使用像Microsoft LAPS这样的产品，使用较长，复杂和随机的密码。</li>
<li>配置组策略以防止本地管理员帐户通过网络进行身份验证。以下GPO示例可防止本地帐户通过网络登录（包括RDP），并阻止域管理员和目录林管理员登录。 GPO包括以下设置：
<pre>1. 拒绝以下账户从网络访问此计算机：本地帐户，目录林管理员(Enterprise Admins)，域管理员
2. 拒绝以下账户通过远程桌面服务登录：本地帐户，目录林管理员，域管理员
3。拒绝本地登录：目录林管理员，域管理员</pre>
</li>
</ul>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjRob3UuY29tL3VwbG9hZHMvMjAxNzA0MTIvMTQ5MTk5MTA5ODkwMTM2NC5qcGc=.jpg"></p>
<p><strong>6.获取活动目录中的数据库文件访问权限(ntds.dit)</strong></p>
<p>活动目录的数据库文件（ntds.dit）包含有关活动目录域中所有对象的所有信息。此数据库中的数据将复制到域中的所有域控制器。该文件还包含所有域用户和计算机帐户的密码哈希值。域控制器（DC）上的ntds.dit文件只能由可以登录到DC的用户访问。很明显，保护这个文件至关重要，因为攻击者访问这个文件会导致整个域沦陷。以下是一个不完整的列表，用于非域管理员情况下，获取NTDS.dit数据方法：</p>
<p><strong>备份路径(备份服务器存储，媒体或网络共享）)</strong><br />
攻击者使用备份共享中的ntds.dit文件访问域控备份并且安装后门。确保存储域控备份的任何网络位置已经被保护。只有域管理员才能访问它们。</p>
<p><strong>在成为域控之前服务器上查找NTDS.dit文件</strong><br />
IFM与DCPromo是使用的”从媒体安装”的安装方式，因此正在升级的服务器不需要通过网络从其他域控复制域数据。<br />
IFM集是NTDS.dit文件的副本，可以在共享上分享用来配置新的域控，或者可能在尚未被提升为域控的服务器上找到。并且此服务器可能没有被正确的保护。</p>
<p><strong>通过虚拟机的管理权限，克隆虚拟域控，并且离线获得数据</strong><br />
访问虚拟域控存储数据并访问域凭据。你运行VMWare吗？ VCenter Admins是完整的管理员，具有全部权限。所以使用VCenter Admin权限可以克隆域控并将数据复制到本地硬盘。</p>
<p>当VM挂起时，也可以从VM内存中提取LSASS数据。不要低估虚拟管理员对虚拟域控制器的影响。如果你的VCenter管理员组是在域控当中，那么你需要尽快改变这一设置。授予相应组的适当权限，不要通过服务器管理员帐户为攻击者提供后门攻击域控的能力。</p>
<p><strong>攻击有权登录到域控的账户</strong><br />
在活动目录中，有几个组是最不应该对域控制器具有默认登录权限的。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjRob3UuY29tL3VwbG9hZHMvMjAxNzA0MTIvMTQ5MTk5MTE0MTMwODU0NS5wbmc=.jpg"></p>
<p>这些组可以默认登录到域控制器：<br /><em></em></p>
<pre>Enterprise Admins (目录林管理员组)
Domain Admins（域管理员组）
Administrators(管理员组)
Backup Operators（备份操作成员）
Account Operators（账户管理组）
Print Operators(打印机操作组)</pre>
<p>这意味着如果攻击者可能会损害帐户管理组或打印机操作组中的帐户，则活动目录域可能会受到威胁，因为这些组对域控制器具有登录权限。</p>
<p>解决方案：</p>
<ul>
<li>限制有权登录到域控制器的组/帐户。</li>
<li>限制具有完整活动目录权限的组/帐户，特别是服务帐户。</li>
<li>保护活动目录数据库的每一个副本，并且不要将它放在比域控信任级别低的主机上面。</li>
</ul>
<p>那么，当一个帐户具有域控制器的登录权限会怎么样？如果是域控，那当然是先把所有的登录凭证全部获取到本地。</p>
<p>1.使用Mimikatz获取所有登录信息<br />
Mimikatz可以从域控上面抓取到所有账户信息：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjRob3UuY29tL3VwbG9hZHMvMjAxNzA0MTIvMTQ5MTk5MTI2NjIxODIyNi5wbmc=.jpg"></p>
<p>2.使用Mimikatz转储LSASS内存（获取域管理员凭据）<br />
Mimikatz可用于转储LSASS，然后从不同系统上的LSASS.dmp文件中提取登录凭据。在域控制器上，这几乎总是导致域管理员凭据。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjRob3UuY29tL3VwbG9hZHMvMjAxNzA0MTIvMTQ5MTk5MTI5ODM0NTI2MC5wbmc=.jpg"></p>
<p>3.使用任务管理器转储LSASS内存（获取域管理员凭据）<br />
一旦LSASS被转储，mimikatz就可以对lsass.dmp进行提取。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjRob3UuY29tL3VwbG9hZHMvMjAxNzA0MTIvMTQ5MTk5MTMxNzE3Mjg5OS5qcGc=.jpg"></p>
<p>4.用NTDSUtil创建媒体安装集(IFM) (用于抓取NTDS.dit文件)<br />
NTDSUtil一个本地运行的针对活动目录数据库(ntds.dit)的命令，并且允许为DCPromo准备IFM集。IFM是用于DCPromo命令中”从媒体安装”这一过程的，所以，在配置域控时就不需要通过网络从其他域控拷贝数据。IFM集，并且也会在<code>c:/temp</code>目录下生成的一份NTDS.dit附件。</p>
<p>该文件可能会在新域控上进行共享，或者可能在尚未升级成域控的新服务器上找到该文件。这样的服务器可能未正确保护。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjRob3UuY29tL3VwbG9hZHMvMjAxNzA0MTIvMTQ5MTk5MTMzNzY4Mzk0MS5wbmc=.jpg"></p>
<p>5.从NTDS.dit文件（和注册表系统配置单元）转储活动目录域凭据。<br />
一旦攻击者拥有NTDS.dit文件的副本（以及某些注册表项用来解密数据库文件），则可以提取活动目录数据库文件中的凭证数据。<br />
一旦攻击者从注册表和NTDS.dit fie获得系统配置单元，他们就拥有所有的管理员凭据！这个截图来自一个安装了Impacket python工具的Kali。使用Impacket中的secretsdump.py python脚本转储DIT。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjRob3UuY29tL3VwbG9hZHMvMjAxNzA0MTIvMTQ5MTk5MTM2OTM0MTUyMC5wbmc=.jpg"></p>
<p>原文发布时间为：2017年4月21日</p>
<p>本文作者：xnianq</p>
<p>本文来自合作伙伴嘶吼，了解相关信息可以关注嘶吼网站。</p>
<p><a href="http://www.4hou.com/technology/4256.html" rel="external nofollow noreferrer">原文链接</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 08:34:19</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%8a%a0%e5%af%86/" title="加密">加密</a>, <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/%e4%b8%bb%e6%9c%ba/" title="主机">主机</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>从活动目录中获取域管理员权限的6种方法的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0P4njM.html" rel="bookmark">C&num;中获取、生成随机数的三种方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了C#中获取.生成随机数的三种方法,本文讲解了Random 类生成法.Guid 类生成法以及RNGCryptoServiceProvider 类生成法,需要的朋友可以参考下 随机数的定义为:产生的所有数字毫无关系. 在实际应用中很多地方会用到随机数,比如需要生成唯一的订单号. 在C#中获取随机数有三种方法: 一.Random 类 Random类默认的无参构造函数可以根据当前系统时钟为种子,进行一系列算法得出要求范围内的伪随机数. 代码如下: Random rd = new R			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6wQlYp.html" rel="bookmark">批处理文件中获取当前所在路径的几种方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:批处理文件中获取当前所在路径的几种方法 @echo off setlocal EnableDelayedExpansion echo 当前正在运行的批处理文件所在路径:!cd! pause @echo off echo 当前目录是:%cd% pause @echo off :: set &quot;abc=%cd%&quot; echo 当前正在运行的批处理文件所在路径:%~dp0 pause @echo off echo 当前的盘符及路径:%~dp0 echo 当前的盘符及路径的短文件名格式:%~			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnRJl0p.html" rel="bookmark">PHP中获取文件扩展名的N种方法小结&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第1种方法: 复制代码 代码如下: function get_extension($file) { substr(strrchr($file, '.'), 1); } 第2种方法: 复制代码 代码如下: function get_extension($file) { return substr($file, strrpos($file, '.')+1); } 第3种方法: 复制代码 代码如下: function get_extension($file) { return end(explode(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQPx7rz.html" rel="bookmark">QT中获取选中的radioButton的两种方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				方法一:采用对象名称进行获取 QRadioButton* pbtn = qobject_cast(ui-&gt;BG-&gt;checkedButton()); QString name = pbtn-&gt;objectName(); if(!QString::compare(name, &quot;radioButton&quot;)) { QMessageBox::information(this, &quot;Tips&quot;, &quot;red chosed!&quot;, QMessag			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwKg7Rz.html" rel="bookmark">JavaScript中获取HTML元素值的三种方法&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JavaScript中取得元素的方法有三种:分别是: 1.getElementById() 方法:通过id取得HTML元素. 2.getElementsByName()方法:通过name取得元素,是一个数组. 3.getElementsByTagName()方法:通过HTML标签取得元素,是一个数组. 如果要取得值可以使用value,如:var x=document.getElementById(&quot;id&quot;).value; 方法一:getElementById() 方法可返回对拥有指定			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR9yVBb.html" rel="bookmark">php文件扩展名判断及获取文件扩展名的N种方法&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				下面代码是php文件扩展名判断 &lt;!DOCTYPE&gt; &lt;html&gt; &lt;head&gt; &lt;meta http-equiv=&quot;Content-type&quot; content=&quot;text/html&quot; charset=&quot;utf-8&quot;&gt; &lt;title&gt;check file&lt;/title&gt; &lt;/head&gt; &lt;body&gt; &lt;b&gt;文件扩展名验证&lt;/b&gt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8jAPxb.html" rel="bookmark">在Windows 2003活动目录中设置和管理发布打印机</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Windows 2000/2003中建立打印机时,打印机和活动目录通过缺省配置成具有整体性,打印机将自动 在活动目录上发布.对于不是运行Windows 2000/2003计算机(如Windows NT 4.0)上的打印机,不能在 AD中进行自动发布,可利用活动目录管理工具或利用system32文件夹中提供的pubprn.vbs脚本在活动目录 中进行手动发布. 4.4.1 Windows 2000/2003域中打印机的发布 在Win2000/2003域中的一台Member Server上安装打印			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRwL0kp.html" rel="bookmark">Windows8&period;1如何获取超级管理员权限</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  1.首先建立记事本,复制以下代码到记事本中,另存为.reg格式,双击注册表即可获得管理员权限. Windows Registry Editor Version 5.00 [-HKEY_CLASSES_ROOT*shellrunas] [HKEY_CLASSES_ROOT*shellrunas] @=&quot;获取超级管理员权限&quot; &quot;Icon&quot;=&quot;C:WindowsSystem32imageres.dll,-78&quot; &quot;NoWorkingDir			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1E17jM.html" rel="bookmark">Win8系统获取最高管理员权限的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Windows系统下,系统的操作权限是有一定的限制的,一般用户登录的账户都是普通管理员,因此很多操作都会受限,为了能拥有更高的操作能力,就必须获取最高的管理员权限,那么在Windows8系统下如何一键快速获取高级管理员权限呢? Windows8一键获取最高管理员权限的方法: 1.在要获得所有权限的文件或者文件夹上,右键,一键取得超级管理员权限,就可以在普通管理员帐户中,快速取得最高权限. 2.取得权限后,再运行程序,就与在超级管理员帐户中运行中是一样的. 3.还有一种情况是由于有程序正在操作这			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBG9M7.html" rel="bookmark" class="title">PhotoShop中的色彩混合模式教程</a>
					<div>
						在多年的ps使用过程中,对颜色理论的不断加深,深深认识到颜色理论给ps设计带来的丰富多彩的变化. 但是往往我们一边欣喜的使用着基于颜色理论的图像处理软件,一边在强调色感的重要而去弱化对色彩理论的研究. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9Mx34Pb.html" rel="bookmark" class="title">数据仓库之我见 （设计篇）</a>
					<div>
						设计|数据 建造数据仓库要做些什么?一般说来,建造数据仓库主要两个方面: 1.     与操作性数据库的接口设计. 2.     数据仓库本身的设计. 看上去好像很简单,但事实并非就这么按部就班,假设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlkJLb.html" rel="bookmark" class="title">挂据：如何让百度竞价流量更精准</a>
					<div>
						不知不觉自己接触竞价推广已经有一段时间了,目前在公司也是主要负责竞价推广这块的工作.自从谷歌退出中国后百度占国内搜索的份额更大了,然而国内的用户大部分网民已经适应了百度搜索引擎,习惯使用百度工具来查询 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyLkkb.html" rel="bookmark" class="title">微软停止对Windows 8的一切支持&colon;淘汰 IE 8&sol;9&sol;10</a>
					<div>
						1月12日对微软来说注定是不平凡的一天,曾经的心爱,Windows 8 宣布停止一切支持,而拥有者海量用户的IE 8/9/10同样不再获得微软的任何更新. 此举意味着,今后无论是功能Bug还是安全威胁 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNg7lb.html" rel="bookmark" class="title">&lbrack;WPF疑难&rsqb; 继承自定义窗口</a>
					<div>
						项目中有不少的弹出窗口,按照美工的设计其外边框(包括最大化,最小化,关闭等按钮)自然不同于Window自身的,但每个弹出框的外边框都是一样的.对其中一个窗口而言,我们要取消其Window边框,并在右上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqL5B2b.html" rel="bookmark" class="title">Qzone项目组视觉设计与标注</a>
					<div>
						像素误差 看自己设计好上线的网站,偶尔会发觉像素行间出现了弹性空间,总在不经意间蹦出一定的差距.有些页面很难发现,比如活动类页面,这类页面多呈不规则造型,在设计上也更加灵活多变.但在portal类的页 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjmoe8z.html" rel="bookmark" class="title">如何激活Vista隐藏的功能</a>
					<div>
						虽然Windows Vista 5219还只是一个不算太成熟的测试版本,但喜欢尝鲜的朋友已经抢先安装,关于Windows Vista的安装和新特性这里就不再多介绍,笔者今天要介绍的是系统中隐藏的几个功 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNLKKM.html" rel="bookmark" class="title">怎样让系统只能用指定U盘</a>
					<div>
						  怎样让系统只能用指定U盘          U盘已经很普及了,而且很多手机功能也带U盘功能了,所以想从别人的电脑里面复制出一些文件,是非常简单的事情,这样对电脑里面资料就有很大的威胁,别急,下面教 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN16ONb.html" rel="bookmark" class="title">Lightroom怎么处理双光源白平衡？</a>
					<div>
						  Lightroom怎么处理双光源白平衡? 1.如果现场有两个不同的光源,情况会怎样呢?本文就和大家讨论一下,如何在Lightroom中调整混合了室内光源和室外光源的白平衡问题.尽管这个例子并不全面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3oPKkb.html" rel="bookmark" class="title">Mac App Store提示可用的更新已更改解决办法</a>
					<div>
						  Mac App Store提示可用的更新已更改怎么办?苹果近日发布了Mac OS X 10.10.4正式版更新,不少Mac用户都第一时间更新到了新版系统,不过有部分通过Mac App Store直 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b329amz.html" rel="bookmark" class="title">【Android-数据报表】初级篇&lbrack;让Highcharts报表显示在Android屏幕&rsqb;</a>
					<div>
						 Highcharts 报表是至今我发现做得最好的报表之一.当然,可能还有更好的我没发现. 此次我们就说说怎么让Highcharts显示在Android设备上. 首先可以在官网查看文档[官方文档]此次 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Q4LDp.html" rel="bookmark" class="title">转&Tab;Lambda表达式解析</a>
					<div>
						(本文转载自:http://www.2cto.com/kf/201404/296631.html) Cocos 2d-x 3.0 版本中引入了C++ 11的特性.其中就包含了回调函中使用Lambda对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NvlDz.html" rel="bookmark" class="title">微软学生中心免费赠送Windows Server 2008 R2标准版</a>
					<div>
						微软学生中心开始对学生免费赠送http://www.aliyun.com/zixun/aggregation/13975.html&quot;&gt;Windows Server 2008 R2标准版 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgR3q5b.html" rel="bookmark" class="title">每个时代都有梦想</a>
					<div>
						引言 09年刚入行互联网,当时我对互联网的理解是:互联网就是电子商务.因为任何互联网产品形态,最终都靠电子商务买卖变现.基于这个理解,我将当时的社区类产品规划为电子商务.于是,我急忙给两个搭档说:我要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKjrjb.html" rel="bookmark" class="title">Windows 2008 R2实战之九：数据库装载工具DSAmain</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   Active Directory 数据库装载工具 (D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKlA8b.html" rel="bookmark" class="title">《地球OL》世界上最大的真人大型角色扮演游戏</a>
					<div>
						游戏信息 游戏名:地球online&lt;地球online&gt;中国阵营区域 英文名:EarthOnLine 简称:EOL 开发团队:盖亚工作组(希腊).盘古工作组(中国).耶和华工作组(中东).泰 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0jZBM.html" rel="bookmark" class="title">C&sol;S模式充电桩管理软件向微服务架构演进</a>
					<div>
						微服务架构在最近两年炒比较火热,最近有个朋友在做充电桩管理软件,该软件是两年前采用C/S模式开发的 ,主要Client(UI)和 Server端两个层次,中间采用数据库共享方式进行通信,如下图所示为充 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12E9dp.html" rel="bookmark" class="title">c语言-怎么样插入符号能让这十个数等于100？</a>
					<div>
						问题描述 怎么样插入符号能让这十个数等于100? 解决方案 明明是9个数字,哪里来的10个数字.这个题目典型的动态规划.用递归 大概写写 int buildn(int start, int end)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5ey5p.html" rel="bookmark" class="title">freemark 判断list是否为空</a>
					<div>
						freemark 判断list是否为空 &lt;#if orgList?? &amp;&amp; (orgList?size &gt; 0) &gt; &lt;#else&gt; &lt;li cla ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12mR3p.html" rel="bookmark" class="title">没革哪有新？看云计算在医疗行业的版图</a>
					<div>
						本文讲的是没革哪有新?看云计算在医疗行业的版图[IT168评论]云技术被全球医疗机构广泛采用.在过去几年中,医疗行业已经意识到云计算的潜力,以及如何帮助他们为患者提供优质的服务.云技术加速了医疗保健行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQjBkp.html" rel="bookmark" class="title">求救呀！这段代码为什么拿不到form？</a>
					<div>
						问题描述 code如下:&lt;/html&gt;&lt;htmllang=&quot;zh&quot;&gt;&lt;head&gt;&lt;title&gt;aaaaa&lt;/title&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bod5YVM.html" rel="bookmark" class="title">中企开源SaaS运营服务率先获三大国际质量体系认证</a>
					<div>
						中企开源日前宣布全面通过ISO20000.ISO27001.ISO9001国际质量管理体系认证,成为中国IT应用运营服务及SaaS运营领域第一家同时获得三大国际质量管理体系认证的企业.这三项认证标志着 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL54X8z.html" rel="bookmark" class="title">ASp&period;net 文本框（TextBox&rpar;计算&comma;判断输入的是否是数字&lowbar;实用技巧</a>
					<div>
						复制代码 代码如下: protected void txtQty_TextChanged(object sender, EventArgs e) { checkForm(); } //检验文本信息是否 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWGZZz.html" rel="bookmark" class="title">jquery必须知道的一些常用特效方法及使用示例&lpar;整理&rpar;&lowbar;jquery</a>
					<div>
						1.jQuery fadeIn() 用于淡入已隐藏的元素. 语法: $(selector).fadeIn(speed,callback); 实例: 复制代码 代码如下: $(&quot;button& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgPRmOp.html" rel="bookmark" class="title">python实现根据用户输入从电影网站获取影片信息的方法&lowbar;python</a>
					<div>
						本文实例讲述了python实现根据用户输入从电影网站获取影片信息的方法.分享给大家供大家参考.具体如下: 这段python代码主要演示了用户终端输入,正则表达式,网页抓取等 #!/usr/bin/en ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdvL53b.html" rel="bookmark" class="title">【算法导论】B树</a>
					<div>
						      一棵B树T是具有如下性质的有根树(设根为root): 1.每个节点x有一下域:   (a)num,当前存储在节点x的关键字个数,关键字以非降序存放,因此key[i]&lt;=key[i+1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk71jOp.html" rel="bookmark" class="title">刚刚接触网络安全技术，新人求帮忙，先行谢谢。</a>
					<div>
						问题描述 我今年22岁,在校生,接触计算机已经有超过9年的时间,由于年少无知,沉迷于网络游戏当中,实在忏愧.今天隔壁学院专3的学生毕业了,我无意中路过他们校门口,而后拾到一本丢弃的&lt;网络与安全技 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk7DOEp.html" rel="bookmark" class="title">使用树莓派红外控制空调和风扇</a>
					<div>
						使用树莓派红外控制空调和风扇 一. 硬件连接: 红外接收器 vcc 连 pin1 (3.3v) gnd 连 pin6(ground) data连 pin12(gpio18) 红外发射器 vcc 连pi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVd6lKM.html" rel="bookmark" class="title">电信联通手机用户今起单向收费中移动做试点</a>
					<div>
						10月1日,按照此前中国电信和中国联通公布在新资费政策,这两家运营商大多数用户今起实行单向收费.此前,中国移动部分品牌业务套餐在全国范围内接听免费,由此,我国电信运营商手机资费的单向收费历程正式迈开实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgWEw8M.html" rel="bookmark" class="title">谷歌启动光纤建设计划：引发美国互联网创业潮</a>
					<div>
						硅谷网11月11日消息,据国外媒体报道,谷歌在美国堪萨斯率先启动的千兆宽带光纤上网计划,不仅给居民带来便利,同时也吸引了许多有志青年前往堪萨斯,寻求超级宽带之下 新的互联网商机. 20岁的迪马拉斯(M ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.039 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
